/* -*- javascript -*- */
(function () {
    var exp = {};
    var factory = function () {
        var exports = false;
        <%= contents %>
    }.bind(exp);
    // export module depending on what kind of environment we are in
    if (typeof exports === 'object' && typeof module !== 'undefined' && module.exports) {
        // commonjs (e.g. NodeJS)
        exp.Pjs = require('P.js');
        factory();
        for (var key in exp.smarttype) {
            exports[key] = exp.smarttype[key];
        }
    } else if (typeof this.define === 'function' && this.define.amd) {
        // AMD (e.g. requirejs)
        this.define('smarttype', ['Pjs'], function (Pjs) {
            exp.Pjs = Pjs;
            factory();
            return exp.smarttype;
        });
    } else {
        // browser
        exp.Pjs = this.Pjs;
        factory();
        this.smarttype = exp.smarttype;
    }
}.call(this));